Package net.sf.saxon.om

## Class MemoSequence.ProgressiveIterator

- java.lang.Object
- - net.sf.saxon.om.MemoSequence.ProgressiveIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `SequenceIterator`, `GroundedIterator`
  Enclosing class:
    MemoSequence

      public final class MemoSequence.ProgressiveIterator
      extends java.lang.Object
      implements SequenceIterator, LastPositionFinder, GroundedIterator

  A ProgressiveIterator starts by reading any items already held in the reservoir; when the reservoir is exhausted, it reads further items from the inputIterator, copying them into the reservoir as they are read.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ProgressiveIterator()` | Create a ProgressiveIterator

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Close the iterator.
    `int` | `getLength()` | Get the last position (that is, the number of items in the sequence)
    `MemoSequence` | `getMemoSequence()` | Get the containing MemoSequence
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `GroundedValue` | `getResidue()` | Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position.
    `GroundedValue` | `materialize()` | Return a value containing all the items in the sequence returned by this SequenceIterator
    `Item` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail`

- - ### Constructor Detail

    - #### ProgressiveIterator

          public ProgressiveIterator()

      Create a ProgressiveIterator

  - ### Method Detail

    - #### getMemoSequence

          public MemoSequence getMemoSequence()

      Get the containing MemoSequence

    - #### next

          public Item next()
                    throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`

    - #### getLength

          public int getLength()
                        throws XPathException

      Get the last position (that is, the number of items in the sequence)
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence
      Throws:
        `XPathException` - if an error occurs evaluating the sequence in order to determine the number of items

    - #### materialize

          public GroundedValue materialize()
                                    throws XPathException

      Return a value containing all the items in the sequence returned by this SequenceIterator
      Specified by:
        `materialize` in interface `GroundedIterator`
      Specified by:
        `materialize` in interface `SequenceIterator`
      Returns:
        the corresponding value
      Throws:
        `XPathException` - if reading the SequenceIterator throws an error

    - #### getResidue

          public GroundedValue getResidue()
                                   throws XPathException

      Description copied from interface: `GroundedIterator`
      Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position. This should be an "in-memory" value, not a Closure. This method does not change the state of the iterator (in particular, it does not consume the iterator).
      Specified by:
        `getResidue` in interface `GroundedIterator`
      Returns:
        the corresponding Value
      Throws:
        `XPathException` - in the cases of subclasses (such as the iterator over a MemoClosure) which cause evaluation of expressions while materializing the value.

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED` and `SequenceIterator.Property.LAST_POSITION_FINDER`. It is always acceptable to return the value zero, indicating that there are no known special properties.